#include <Client.h>
#include <Ethernet.h>
#include <stdio.h>
#include <LB_GPS.h>
#include <string.h>
#include <stdlib.h>

#define TIEMPO_ESPERA 5000
//Tiempo de espera entre conexion y conexion con el servidor, es en segundos, coloca el tiempo deseado
#define TIEMPO_ESPERA2 1200000
#define TIEMPO_ALERT 2000

int valorh = 0;
int valort = 0;
int temperatura = 0;
int humedad = 0;
int valor2 = 0;
int n = 1;
// ESTO ES LO QUE TENEIS QUE MODIFICAR
//Tienes que darles numeros a los sensores diferentes, si no el ordenador no te creara distintas graficas
int numerosensor = 1;
//Mascara del arduino, cambiar si se desea, o cambiarla si se tienen varios arduinos
byte mac[] = { 0xDE, 0xAD, 0xB1, 0xE2, 0x1E, 0xED };
// Ip de los arduino, modificarlo entre ellos
byte arduinoip[] = { 192, 168, 0, 115 };
// Ip del servidor, colocarle la ip del ordenador al que quieren que le envie la informacion
byte ip[] = { 192, 168, 0, 100 };
Client client(ip,9999); //Decimos que trabaje como client
// AQUI ACABA LA MODIFICACION
char latitud[20];
char longitud[20];
int latitudd;
int longitudd;
boolean Alert1 = false;
char* globalalert_str;

void setup(){
  Ethernet.begin(mac,arduinoip); // Le damos una ip al arduino
  Serial.begin(9600);
  delay(1000);
  pinMode(3,INPUT); // Decimos los pines, donde tiene que obtener la informacion de los sensores conectados al arduino 
  pinMode(4,INPUT);
  GPS.init();    
  Serial.println("Conectando..."); 
    if (client.connect()){  // Conectando
      Serial.println("Conectado");
    }else{
      Serial.println("Fallo en conexion");
    }
}      
void loop(){
    if(client.connected()){
     if(client.available()){
	//Obtenemos la senyal de confirmacion de conexion del servidor.
        int i = 0;
        char buf[255] = {}, c;
        while ((c = client.read()) != -1) {
           buf[i++] = c;
           if (i == sizeof(buf)){
             break;
           }
        }
        Serial.print(buf);
	//Comprobamos si es valida la confirmacion
        if(strcmp(buf, "GET /xml-arduino/protocol HTTP/1.1\nHost: localhost\n") == 0){
          Serial.println("Y es correcta");
	// Es valida, y obtenemos la informacion de los sensores y efectuamos unas funciones para pasar de 0 a 1024 a grados(temperatura) y a porcentaje (humedad)
          valorh=analogRead(4);
          valort=analogRead(3);
          humedad = (valorh * 100.0)/1024.0;
          temperatura = (5.0 * valort * 100.0)/1024.0;
          GPS.getRaw(100);
           char *p = GPS.inBuffer;
  char *z;
  char *str;
  //GPGGA,065550.000,5535.620,N,01257.330,E,0,00,99.0,-020.9,M,40.9,M,,
  while ((str = strtok_r(p, ",", &p)) != NULL){
    if(n==2){
      sprintf(latitud, "%s",str); 
    }
    if(n==3){
      if(strcmp(str, "N") == 0){
        latitudd = 1;
      }else{
        latitudd = 0; 
      }
    }
    else if( n==4){
      sprintf(longitud, "%s", str);
    }
    else if(n == 5){
      if(strcmp(str, "W") == 0){
        longitudd = 1;
      }else{
        longitudd = 0; 
      }
    }else if(n==6){
      if(strcmp(str, "0") == 0){
         sprintf(latitud, "99999.999");
         sprintf(longitud, "99999.999");
       } 
    }
    n++;
  }
          char buf[1024];
      // Efectuamos el envio al servidor con toda la informacion, donde se envia la informacion para construir el xml en el servidor
          sprintf(buf, "HTTP/1.1 200 OK\n"
                    "Content-Type: text/plain;charset=UTF-8\n"
                    "Content-Length: 49\n\n"
                    "<xml><entry><sensor>%d</sensor><humedity>%d</humedity><temperature>%d</temperature><lat>%s</lat><long>%s</long></entry></xml>", numerosensor, humedad, temperatura, latitud, latitudd, longitud, longitudd);
          client.print(buf);

        } else {
          Serial.println("pero es una peticion invalida");
          Serial.println(buf);
        }
        delay(TIEMPO_ESPERA2);
     }
     Serial.println("No hay peticiones del servidor");
     delay(TIEMPO_ESPERA);
   } else {
      client.stop();
      if (client.connect()){
        Serial.println("Conectado con exito");
      }else{
        Serial.println("No me he podido reconectar");
      delay(2000);
    }
  }
}
